/// <summary>
        /// Set the FailureResolutionType for the current ErrorOption by retrieving it from the friendly description used for the ComboBox item
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ComboBoxResolutions_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AutoFailureHandlingOptions fOpts = (AutoFailureHandlingOptions)DataContext;

            if (ComboBoxResolutions.SelectedItem != null)
            {
                //todo: data binding works for everything but this text. Can it be invalidated or otherwise updated?
                ResolutionDescriptionText.Text = fOpts.SelectedResolution.FriendlyDescription;
            }
        }
Ejemplo n.º 2
0
        public FailureCatcherWindow(AutoOptionsSettings aOSettings, AutoFailureHandlingOptions caughtFailOpts, UIApplication uiApp = null) : this()
        {
            DataContext = aOSettings;
            CaughtFailurePanel.DataContext = caughtFailOpts;

            //Center the window on the main Revit window. uiApp is not guaranteed to be set
            if (uiApp != null)
            {
                var    revitWindow   = uiApp.MainWindowExtents;
                Double centerWindowX = (revitWindow.Left + revitWindow.Right) / 2;
                Double centerWindowY = (revitWindow.Top + revitWindow.Bottom) / 2;
                Left = centerWindowX - Width / 2;
                Top  = centerWindowY - Height / 2;
            }
        }
        /// <summary>
        /// This is an event handler that responds to a failure according to the current settings
        /// </summary>
        /// <param name="sender">The sending object, i.e. the Revit application</param>
        /// <param name="e">The event arguments</param>
        public void AutoOptionsFailureHandler(Object sender, Autodesk.Revit.DB.Events.FailuresProcessingEventArgs e)
        {
            //don't process if handling is turned off
            if (currentSettings.HandlingActive == false)
            {
                return;
            }

            //update the uiApp reference
            Application RevitApp = sender as Application;

            uiApp = new UIApplication(RevitApp);

            FailuresAccessor fa = e.GetFailuresAccessor();
            //this is the action that will be taken to attempt resolution. Default is to continue the default Revit failure processing
            FailureProcessingResult action = FailureProcessingResult.Continue;

            foreach (FailureMessageAccessor fma in fa.GetFailureMessages())
            {
                AutoFailureHandlingOptions aFOpts = currentSettings.AllFailureOptions
                                                    .Where(x => x.FailureGuid == fma.GetFailureDefinitionId().Guid)
                                                    .FirstOrDefault();

                if (aFOpts != null)
                {
                    //Show the CatchFailures dialog if a failure was caught
                    if (currentSettings.InteractiveModeEnabled)
                    {
                        try
                        {
                            //todo: clone to allow roll-back?
                            FailureCatcherWindow failWin = new FailureCatcherWindow(currentSettings, aFOpts, uiApp);

                            Boolean?result = failWin.ShowDialog();

                            if (result.Value)
                            {
                                //Write changes to the .ini
                                currentSettings.LastUpdate = DateTime.Now;
                                IAutoOptionsRepository settingsRepo = new AutoOptionsConfigFileRepo();
                                settingsRepo.WriteAutoOptions(currentSettings);
                            }
                        }
                        catch (Exception ex)
                        {
                            TaskDialog.Show("ex", ex.Message + "\n" + ex.StackTrace);
                            throw;
                        }
                    }

                    FailureResolutionOption selectedResolution = aFOpts.SelectedResolution;
                    if (selectedResolution is AutoOptionsResolution)
                    {
                        try
                        {
                            switch (((AutoOptionsResolution)selectedResolution).Resolution)
                            {
                            case AutoOptionsResolutionType.NoAction:
                                break;

                            case AutoOptionsResolutionType.DeleteAffected:
                                fa.DeleteElements(fma.GetFailingElementIds().ToList());
                                action = FailureProcessingResult.ProceedWithCommit;
                                break;

                            case AutoOptionsResolutionType.CancelTransaction:
                                //todo: not working, being overwritten?
                                action = FailureProcessingResult.ProceedWithRollBack;
                                e.SetProcessingResult(action);
                                fa.RollBackPendingTransaction();
                                return;

                            case AutoOptionsResolutionType.HideWarning:
                                //todo: check if actually is a warning?
                                fa.DeleteWarning(fma);
                                break;

                            default:
                                break;
                            }
                        }
                        catch (Exception ex)
                        {
                            TaskDialog.Show("Dispatcher", ex.Message + "\n" + ex.Source + "\n" + ex.StackTrace);
                        }
                    }
                    else if (selectedResolution is RevitResolution)
                    {
                        try
                        {
                            FailureResolutionType fRT = ((RevitResolution)selectedResolution).Resolution;

                            if (fma.HasResolutionOfType(fRT))
                            {
                                fma.SetCurrentResolutionType(fRT);
                                fa.ResolveFailure(fma);
                                action = FailureProcessingResult.ProceedWithCommit;
                            }
                            else
                            {
                                TaskDialog.Show("AutoOptions", "The selected automatic resolution \n***" + aFOpts.SelectedResolution.FriendlyCaption + " (" + fRT + ")***\ncan't be used");
                            }
                        }
                        catch (Exception ex)
                        {
                            TaskDialog.Show("Dispatcher", ex.Message + "\n" + ex.Source + "\n" + ex.StackTrace);
                        }
                    }
                }
            }

            e.SetProcessingResult(action);
        }
 public void SetTargetFailure(AutoFailureHandlingOptions targetFail)
 {
     DataContext = targetFail;
 }